
(function ($) {

	var options = {
		series: {
			drawshape: 0
		}
	};

	function init(plot) {
		
		function drawDisk(plot, ctx, series) {
			if (series.drawshape == 1) {

				/*
				var plotOffset = plot.getPlotOffset();
				var xaxis = series.xaxis;
				var yaxis = series.yaxis;
				var data = series.data;
				var x0 = xaxis.p2c(10) + plotOffset.left;
				var y0 = yaxis.p2c(10) + plotOffset.top;
				var x = xaxis.p2c(30) + plotOffset.left;
				var y = yaxis.p2c(30) + plotOffset.top;
				var x1 = xaxis.p2c(12) + plotOffset.left;
				var y1 = yaxis.p2c(12) + plotOffset.top;
				var x2 = xaxis.p2c(20) + plotOffset.left;
				var y2 = yaxis.p2c(20) + plotOffset.top;
				var x3 = xaxis.p2c(22) + plotOffset.left;
				var y3 = yaxis.p2c(22) + plotOffset.top;
				var x4 = xaxis.p2c(28) + plotOffset.left;
				var y4 = yaxis.p2c(28) + plotOffset.top;

				ctx.beginPath();

				ctx.moveTo(x0, y0);
				ctx.lineTo(x, y0);
				ctx.lineTo(x, y);
				ctx.lineTo(x0, y);
				ctx.lineTo(x0, y0);
				
				ctx.moveTo(x1, y1);
				ctx.lineTo(x1, y2);
				ctx.lineTo(x2, y2);
				ctx.lineTo(x2, y1);
				ctx.lineTo(x1, y1);
	
				ctx.moveTo(x3, y3);
				ctx.lineTo(x3, y4);
				ctx.lineTo(x4, y4);
				ctx.lineTo(x4, y3);
				ctx.lineTo(x3, y3);
	
				ctx.fillStyle = "#FF0000";
				ctx.fill();
				// ctx.fill("evenodd");

				ctx.strokeStyle = "rgba(0.5,0.5,0.5,0.5)";
				ctx.lineWidth = 1;
				ctx.stroke();

				ctx.closePath();
				*/


				var plotOffset = plot.getPlotOffset();
				var xaxis = series.xaxis;
				var yaxis = series.yaxis;
				var data = series.data;

				var offset_x = plotOffset.left;
				var offset_y = plotOffset.top;

				function coord_x(x) {
					return offset_x + xaxis.p2c(x)
				};

				function coord_y(y) {
					return offset_y + yaxis.p2c(y)
				};

				ctx.beginPath();

				var chk = 0;

				for (var i = 0; i < data.length; i++) {
					if (data[i] == null) {
						chk = 0;
						continue;
					}
					if (chk == 0) {
						ctx.moveTo(coord_x(data[i][0]), coord_y(data[i][1]));
						chk = 1;
					} else {
						ctx.lineTo(coord_x(data[i][0]), coord_y(data[i][1]));
					}
				}
				ctx.fillStyle = series.color;
				ctx.fill("evenodd");

				/*
				ctx.strokeStyle = "rgba(0.5,0.5,0.5,0.5)";
				ctx.lineWidth = 0;
				ctx.stroke();
				*/

				ctx.closePath();
			}
		}

		plot.hooks.drawSeries.push(drawDisk);
	}

	$.plot.plugins.push({
		init: init,
		options: options
	});
})(jQuery);
