/* There goes my helpers */

function hex2rgb( colour ) {
    var r,g,b;
    if (colour.charAt(0) == '#') {
        colour = colour.substr(1);
    }

    r = "" + colour.charAt(0) + colour.charAt(1); //get color at 1 position
    g = "" + colour.charAt(2) + colour.charAt(3);
    b = "" + colour.charAt(4) + colour.charAt(5);

    r = parseInt( r, 16 ); //parse to int
    g = parseInt( g, 16 );
    b = parseInt( b , 16 );
    return new Array(r, g, b);
}

function dec2hex(i) {
    return (i+0x100).toString(16).substr(-2).toUpperCase();
} 

/* Generate colors from begin color [r,g,b] array to end color [r,g,b] array */

function genColors(a, b) {
	var myColors = [];
	var bands = 40;        // Bands is the length of your domain
    var i; 
    var delta = [];        // Difference between color in each channel
                           // Compute difference between each color
    for (i = 0; i < 3; i++){
        delta[i] = (a[i] - b[i]) / (bands + 1);
    }

                           // Use that difference to create your bands
    for (i = 0; i <= bands + 1; i++){
        var r = Math.round(a[0] - delta[0] * i);
        var g = Math.round(a[1] - delta[1] * i);
        var b = Math.round(a[2] - delta[2] * i);
        
        var finalColor = "#" + dec2hex(r) + dec2hex(g) + dec2hex(b);
        myColors.push(finalColor);
    }

    return myColors;
}

/* Functions for formatting data */

function formatDate(date) {

	var dd = date.getDate();

	if ( dd < 10 ) 
		dd = '0' + dd;

	var mm = date.getMonth()+1;

	if ( mm < 10 ) 
		mm = '0' + mm;

	var yy = date.getFullYear() % 100;

  	if ( yy < 10 ) 
  		yy = '0' + yy;

  	return dd + '.' + mm + '.' + yy;
}


/* Buttons highlighting */

function highlight() {
  	$(this).siblings().each(function() {
		$(this).removeClass("highlight");
  	});
	$(this).addClass("highlight");
}