#!/usr/bin/env python
import numpy as np
import simplejson as json
import ConfigParser
import re
import sys
import cgi, cgitb
import adeitools as adei

#cgitb.enable()
#reqparams = cgi.FieldStorage()

def doSomething(tinit, tspan, stamp, sensor, group, server):
    data = {}
    data['stamp'] = stamp

    dataMasks = server.getMaskList(sensor, group)
    time, dataArray = server.getDataByMask(dataMasks, group, tinit, tspan)

    data['time'] = time
    data['data'] = dataArray.tolist()
    data['axis_unit'] = [None]
    data['axis2_unit'] = [None]
    data['axis2_values'] = [None]
    
    return data

config = ConfigParser.ConfigParser()
config.read("../hatpro.ini")

content_type = 'text/plain; charset="UTF-8"'
sys.stdout.write('Content-type: %s\n\n' % content_type)

c = re.compile('^sensor\d+')

for sectname in config.sections():
    if c.match(sectname):
        settings = config._sections[sectname]

        # server 
        server_settings = config._sections[settings['server']]
        server = adei.adeiserver(server_settings['db_name'], 
                server_settings['db_server'], 
                server_settings['db_host'])

        # settings
        device = settings['device']
        group = settings['group']
        sensor = settings['sensor']
        method = settings['method']

        # important time points
        t0 = adei.secSinceEpoch(server.lastDatetime(group))
        t00 = adei.secSinceEpoch(server.lastDay(group))
        t01 = t00 - 86400
        t02 = t00 - 86400 * 2

        for timekey in ['0d', '1d', '2d']:
            filename = "../cache/%s.%s.%s.json" % (device, sensor, timekey)
        
            # decide update_level
            # if update_level is 0, no update
            # if update_level is 1, update for '0d'
            # if update_level is 2, update for all ('0d', '1d', '2d')
            update_level = 0
            newstamp = t0
            try:
                json_data = open(filename).read()
                oldstamp = json.loads(json_data)['stamp']
                daystamp = t00

                if oldstamp < newstamp:
                    update_level += 1
                if oldstamp < daystamp:
                    update_level += 1
            except:
                update_level = 2
            print update_level

            if timekey == '0d':
                if update_level >= 1:
                    dataDict = doSomething(t00, 86400, newstamp, sensor, group, server)
                    foutput = open(filename, "w")
                    json.dump(dataDict, foutput)
                    foutput.close()
            if timekey == '1d':
                if update_level == 2:
                    dataDict = doSomething(t01, 86400, newstamp, sensor, group, server)
                    foutput = open(filename, "w")
                    json.dump(dataDict, foutput)
                    foutput.close()
            if timekey == '2d':
                if update_level == 2:
                    dataDict = doSomething(t02, 86400, newstamp, sensor, group, server)
                    foutput = open(filename, "w")
                    json.dump(dataDict, foutput)
                    foutput.close()


print "oK"
sys.stdout.close()


#def main():
#    for data_field in config.HATPRO.keys():
#        data_group = config.HATPRO[data_field]['group']
#        data_type  = config.HATPRO[data_field]['type']
#
#        print data_group, data_type, data_field
#
#        t0 = adei.lastDatetime(data_group)
#        t00 = adei.lastDay(data_group)
#
#        t0 = adei.secSinceEpoch(t0)
#        t00 = adei.secSinceEpoch(t00)
#        t01 = t00 - 86400
#        t02 = t00 - 86400 * 2
#
#        filename_0d = "cache/%s.%s.0d.json" % ("HATPRO", data_field)
#        filename_1d = "cache/%s.%s.1d.json" % ("HATPRO", data_field)
#        filename_2d = "cache/%s.%s.2d.json" % ("HATPRO", data_field)
#
#        if data_type != '1d':
#            continue
#
#        maskList = adei.getMaskList(data_field, data_group)
#
#        # 0d 
#        timespan = 86400
#        update_flag = 0
#        try:
#            json_data = open(filename_0d).read()
#            ts = json.loads(json_data)['timestamp']
#            if ts < t0:
#                update_flag += 1
#            if ts < t00:
#                update_flag += 1
#        except:
#            update_flag = 2
#
#        if update_flag >= 1:
#            dataArray = adei.getDataByMask(maskList, data_group, t00, timespan)
#            dataDict = {"timestamp": t0, "name": data_field, "value":dataArray[0].tolist()}
#
#            with open(filename_0d, 'w') as outfile:
#                json.dump(dataDict, outfile)
#
#        # 1d
#        timespan = 86400
#        update_flag = 0
#        try:
#            json_data = open(filename_1d).read()
#            ts = json.loads(json_data)['timestamp']
#            if ts < t0:
#                update_flag += 1
#            if ts < t00:
#                update_flag += 1
#        except:
#            update_flag = 2
#
#        if update_flag == 2:
#            dataArray = adei.getDataByMask(maskList, data_group, t01, timespan)
#            dataDict = {"timestamp": t0, "name": data_field, "value":dataArray[0].tolist()}
#
#            with open(filename_1d, 'w') as outfile:
#                json.dump(dataDict, outfile)
#
#        # 2d
#        timespan = 86400
#        update_flag = 0
#        try:
#            json_data = open(filename_2d).read()
#            ts = json.loads(json_data)['timestamp']
#            if ts < t0:
#                update_flag += 1
#            if ts < t00:
#                update_flag += 1
#        except:
#            update_flag = 2
#
#        if update_flag == 2:
#            dataArray = adei.getDataByMask(maskList, data_group, t02, timespan)
#            dataDict = {"timestamp": t0, "name": data_field, "value":dataArray[0].tolist()}
#
#            with open(filename_2d, 'w') as outfile:
#                json.dump(dataDict, outfile)
#
#
#
#    #    tr, t0 =  re.match(r"([0-9]+)([a-z]+)", reqparams['timespan'].value).groups()
#    #    if t0 == 'd':
#    #        timeinsec = 86400
#    #        t0 = adei.secSinceEpoch(adei.lastDay(data_group)) - 86400 * int(tr)
#    #    elif t0 == 'h':
#    #        timeinsec = 3600*int(tr)
#    #        t0 = adei.secSinceEpoch(adei.lastDatetime(data_group)) - timeinsec
#    #
#    #    maskList = adei.getMaskList(data_field, data_group)
#    #
#    #    dataArray = adei.getDataByMask(maskList, data_group, t0, timeinsec)
#    #    dataDict = {"name": data_field, "value":dataArray[0].tolist()}
#
#    #    sys.stdout.write("Content-Type: application/json\n\n")
#    #    sys.stdout.write(json.dumps(dataDict))
#    #    sys.stdout.write("\n")
#    #    sys.stdout.close()
#
#
#if __name__ == "__main__":
#    sys.exit(main())


